Plank.Surface – plank Reference Manual

# Surface

## Object Hierarchy:

## Description:

public class Surface : Object

A surface is a wrapper class for a Cairo.Surface. It encapsulates a surface/context and provides utility methods.

Namespace: Plank
Package: plank

## Content:

### Properties:

- public Context Context { get; construct; }
  A Cairo.Context for the surface.
- public int Height { get; construct; }
  The height of the surface.
- public Surface Internal { get; construct; }
  The internal Cairo.Surface backing the surface.
- public int Width { get; construct; }
  The width of the surface.

### Creation methods:

- public Surface (int width, int height)
  Creates a new surface.
- public Surface.with_cairo_surface (int width, int height, Surface model)
  Creates a new surface compatible with an existing Cairo.Surface.
- public Surface.with_internal (ImageSurface image)
  Creates a new surface with the given Cairo.ImageSurface as Internal.
- public Surface.with_surface (int width, int height, Surface model)
  Creates a new surface compatible with an existing Surface.

### Methods:

- public Color average_color ()
  Computes and returns the average color of the surface.
- public void clear ()
  Clears the entire surface.
- public Surface copy ()
  Create a copy of the surface
- public Surface create_mask (double threshold, out Rectangle extent)
  Computes the mask of the surface.
- public void exponential_blur (int radius)
  Performs an exponential blur on the surface.
- public void fast_blur (int radius, int process_count = 1)
  Performs a fast blur on the surface.
- public void gaussian_blur (int radius)
  Performs a gaussian blur on the surface. Note: This method is wickedly slow
- public Surface scaled_copy (int width, int height)
  Create a scaled copy of the surface
- public Pixbuf to_pixbuf ()
  Saves the current surface to a Gdk.Pixbuf.

### Inherited Members:

All known members inherited from class GLib.Object

- @get
- @new
- @ref
- @set
- add_toggle_ref
- add_weak_pointer
- bind_property
- connect
- constructed
- disconnect
- dispose
- dup_data
- dup_qdata
- force_floating
- freeze_notify
- get_class
- get_data

- get_property
- get_qdata
- get_type
- getv
- interface_find_property
- interface_install_property
- interface_list_properties
- is_floating
- new_valist
- new_with_properties
- newv
- notify
- notify_property
- ref_count
- ref_sink
- remove_toggle_ref
- remove_weak_pointer

- replace_data
- replace_qdata
- set_data
- set_data_full
- set_property
- set_qdata
- set_qdata_full
- set_valist
- setv
- steal_data
- steal_qdata
- thaw_notify
- unref
- watch_closure
- weak_ref
- weak_unref